#ifndef _H_4A42628F6DCA0768D5633D2BD1AD12F6_DockInfraRed_DCPS_H_
#define _H_4A42628F6DCA0768D5633D2BD1AD12F6_DockInfraRed_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DockInfraRed_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class DockInfraRed_TypeSupportInterface;

            typedef DockInfraRed_TypeSupportInterface * DockInfraRed_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DockInfraRed_TypeSupportInterface> DockInfraRed_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DockInfraRed_TypeSupportInterface> DockInfraRed_TypeSupportInterface_out;


            class DockInfraRed_DataWriter;

            typedef DockInfraRed_DataWriter * DockInfraRed_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DockInfraRed_DataWriter> DockInfraRed_DataWriter_var;
            typedef DDS_DCPSInterface_out < DockInfraRed_DataWriter> DockInfraRed_DataWriter_out;


            class DockInfraRed_DataReader;

            typedef DockInfraRed_DataReader * DockInfraRed_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DockInfraRed_DataReader> DockInfraRed_DataReader_var;
            typedef DDS_DCPSInterface_out < DockInfraRed_DataReader> DockInfraRed_DataReader_out;


            class DockInfraRed_DataReaderView;

            typedef DockInfraRed_DataReaderView * DockInfraRed_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DockInfraRed_DataReaderView> DockInfraRed_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DockInfraRed_DataReaderView> DockInfraRed_DataReaderView_out;

            struct DockInfraRed_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DockInfraRed_, struct DockInfraRed_Seq_uniq_> DockInfraRed_Seq;
            typedef DDS_DCPSSequence_var < DockInfraRed_Seq> DockInfraRed_Seq_var;
            typedef DDS_DCPSSequence_out < DockInfraRed_Seq> DockInfraRed_Seq_out;

            class  DockInfraRed_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DockInfraRed_TypeSupportInterface_ptr _ptr_type;
                typedef DockInfraRed_TypeSupportInterface_var _var_type;

                static DockInfraRed_TypeSupportInterface_ptr _duplicate (DockInfraRed_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DockInfraRed_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DockInfraRed_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DockInfraRed_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DockInfraRed_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DockInfraRed_TypeSupportInterface () {};
                ~DockInfraRed_TypeSupportInterface () {};
            private:
                DockInfraRed_TypeSupportInterface (const DockInfraRed_TypeSupportInterface &);
                DockInfraRed_TypeSupportInterface & operator = (const DockInfraRed_TypeSupportInterface &);
            };

            class  DockInfraRed_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DockInfraRed_DataWriter_ptr _ptr_type;
                typedef DockInfraRed_DataWriter_var _var_type;

                static DockInfraRed_DataWriter_ptr _duplicate (DockInfraRed_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DockInfraRed_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DockInfraRed_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DockInfraRed_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DockInfraRed_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DockInfraRed_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DockInfraRed_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DockInfraRed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DockInfraRed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DockInfraRed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DockInfraRed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DockInfraRed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DockInfraRed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DockInfraRed_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DockInfraRed_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DockInfraRed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DockInfraRed_& instance_data) = 0;

            protected:
                DockInfraRed_DataWriter () {};
                ~DockInfraRed_DataWriter () {};
            private:
                DockInfraRed_DataWriter (const DockInfraRed_DataWriter &);
                DockInfraRed_DataWriter & operator = (const DockInfraRed_DataWriter &);
            };

            class  DockInfraRed_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DockInfraRed_DataReader_ptr _ptr_type;
                typedef DockInfraRed_DataReader_var _var_type;

                static DockInfraRed_DataReader_ptr _duplicate (DockInfraRed_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DockInfraRed_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DockInfraRed_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DockInfraRed_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DockInfraRed_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DockInfraRed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DockInfraRed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DockInfraRed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DockInfraRed_& instance) = 0;

            protected:
                DockInfraRed_DataReader () {};
                ~DockInfraRed_DataReader () {};
            private:
                DockInfraRed_DataReader (const DockInfraRed_DataReader &);
                DockInfraRed_DataReader & operator = (const DockInfraRed_DataReader &);
            };

            class  DockInfraRed_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DockInfraRed_DataReaderView_ptr _ptr_type;
                typedef DockInfraRed_DataReaderView_var _var_type;

                static DockInfraRed_DataReaderView_ptr _duplicate (DockInfraRed_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DockInfraRed_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DockInfraRed_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DockInfraRed_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DockInfraRed_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DockInfraRed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DockInfraRed_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DockInfraRed_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DockInfraRed_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DockInfraRed_& instance) = 0;

            protected:
                DockInfraRed_DataReaderView () {};
                ~DockInfraRed_DataReaderView () {};
            private:
                DockInfraRed_DataReaderView (const DockInfraRed_DataReaderView &);
                DockInfraRed_DataReaderView & operator = (const DockInfraRed_DataReaderView &);
            };
        }

    }

}

#endif
