#ifndef _H_4D653A9A0432AC29A93B898480D0C083_ScanAngle_DCPS_H_
#define _H_4D653A9A0432AC29A93B898480D0C083_ScanAngle_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScanAngle_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class ScanAngle_TypeSupportInterface;

            typedef ScanAngle_TypeSupportInterface * ScanAngle_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScanAngle_TypeSupportInterface> ScanAngle_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScanAngle_TypeSupportInterface> ScanAngle_TypeSupportInterface_out;


            class ScanAngle_DataWriter;

            typedef ScanAngle_DataWriter * ScanAngle_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScanAngle_DataWriter> ScanAngle_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScanAngle_DataWriter> ScanAngle_DataWriter_out;


            class ScanAngle_DataReader;

            typedef ScanAngle_DataReader * ScanAngle_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScanAngle_DataReader> ScanAngle_DataReader_var;
            typedef DDS_DCPSInterface_out < ScanAngle_DataReader> ScanAngle_DataReader_out;


            class ScanAngle_DataReaderView;

            typedef ScanAngle_DataReaderView * ScanAngle_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScanAngle_DataReaderView> ScanAngle_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScanAngle_DataReaderView> ScanAngle_DataReaderView_out;

            struct ScanAngle_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ScanAngle_, struct ScanAngle_Seq_uniq_> ScanAngle_Seq;
            typedef DDS_DCPSSequence_var < ScanAngle_Seq> ScanAngle_Seq_var;
            typedef DDS_DCPSSequence_out < ScanAngle_Seq> ScanAngle_Seq_out;

            class  ScanAngle_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScanAngle_TypeSupportInterface_ptr _ptr_type;
                typedef ScanAngle_TypeSupportInterface_var _var_type;

                static ScanAngle_TypeSupportInterface_ptr _duplicate (ScanAngle_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanAngle_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScanAngle_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanAngle_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanAngle_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScanAngle_TypeSupportInterface () {};
                ~ScanAngle_TypeSupportInterface () {};
            private:
                ScanAngle_TypeSupportInterface (const ScanAngle_TypeSupportInterface &);
                ScanAngle_TypeSupportInterface & operator = (const ScanAngle_TypeSupportInterface &);
            };

            class  ScanAngle_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScanAngle_DataWriter_ptr _ptr_type;
                typedef ScanAngle_DataWriter_var _var_type;

                static ScanAngle_DataWriter_ptr _duplicate (ScanAngle_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanAngle_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScanAngle_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanAngle_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanAngle_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScanAngle_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScanAngle_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScanAngle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScanAngle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScanAngle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScanAngle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScanAngle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScanAngle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScanAngle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScanAngle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScanAngle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanAngle_& instance_data) = 0;

            protected:
                ScanAngle_DataWriter () {};
                ~ScanAngle_DataWriter () {};
            private:
                ScanAngle_DataWriter (const ScanAngle_DataWriter &);
                ScanAngle_DataWriter & operator = (const ScanAngle_DataWriter &);
            };

            class  ScanAngle_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScanAngle_DataReader_ptr _ptr_type;
                typedef ScanAngle_DataReader_var _var_type;

                static ScanAngle_DataReader_ptr _duplicate (ScanAngle_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanAngle_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScanAngle_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanAngle_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanAngle_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanAngle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanAngle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanAngle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanAngle_& instance) = 0;

            protected:
                ScanAngle_DataReader () {};
                ~ScanAngle_DataReader () {};
            private:
                ScanAngle_DataReader (const ScanAngle_DataReader &);
                ScanAngle_DataReader & operator = (const ScanAngle_DataReader &);
            };

            class  ScanAngle_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScanAngle_DataReaderView_ptr _ptr_type;
                typedef ScanAngle_DataReaderView_var _var_type;

                static ScanAngle_DataReaderView_ptr _duplicate (ScanAngle_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScanAngle_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScanAngle_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScanAngle_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScanAngle_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScanAngle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScanAngle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScanAngle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScanAngle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScanAngle_& instance) = 0;

            protected:
                ScanAngle_DataReaderView () {};
                ~ScanAngle_DataReaderView () {};
            private:
                ScanAngle_DataReaderView (const ScanAngle_DataReaderView &);
                ScanAngle_DataReaderView & operator = (const ScanAngle_DataReaderView &);
            };
        }

    }

}

#endif
