#ifndef H_151023995F00544935B425A9F6A868F6_SensorState_SPLTYPES_H
#define H_151023995F00544935B425A9F6A868F6_SensorState_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_SensorState_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"



extern c_metaObject __SensorState__kobuki_ros_interfaces__load (c_base base);

extern c_metaObject __SensorState__kobuki_ros_interfaces_msg__load (c_base base);

extern c_metaObject __SensorState__kobuki_ros_interfaces_msg_dds___load (c_base base);

extern c_metaObject __SensorState__kobuki_ros_interfaces_msg_dds__SensorState_Constants__load (c_base base);

extern const char *kobuki_ros_interfaces_msg_dds__SensorState__metaDescriptor[];
extern const int kobuki_ros_interfaces_msg_dds__SensorState__metaDescriptorArrLength;
extern const int kobuki_ros_interfaces_msg_dds__SensorState__metaDescriptorLength;
extern c_metaObject __kobuki_ros_interfaces_msg_dds__SensorState___load (c_base base);
struct _kobuki_ros_interfaces_msg_dds__SensorState_ ;
extern  v_copyin_result __kobuki_ros_interfaces_msg_dds__SensorState___copyIn(c_base base, const struct kobuki_ros_interfaces::msg::dds_::SensorState_ *from, struct _kobuki_ros_interfaces_msg_dds__SensorState_ *to);
extern  void __kobuki_ros_interfaces_msg_dds__SensorState___copyOut(const void *_from, void *_to);
struct _kobuki_ros_interfaces_msg_dds__SensorState_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_ushort time_stamp_;
    c_octet bumper_;
    c_octet wheel_drop_;
    c_octet cliff_;
    c_ushort left_encoder_;
    c_ushort right_encoder_;
    c_octet left_pwm_;
    c_octet right_pwm_;
    c_octet buttons_;
    c_octet charger_;
    c_octet battery_;
    c_sequence bottom_;
    c_sequence current_;
    c_octet over_current_;
    c_ushort digital_input_;
    c_sequence analog_input_;
};

#undef OS_API
#endif
