// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kobuki_ros_interfaces:msg/SensorState.idl
// generated code does not contain a copyright notice
#include "kobuki_ros_interfaces/msg/sensor_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `bottom`
// Member `current`
// Member `analog_input`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
kobuki_ros_interfaces__msg__SensorState__init(kobuki_ros_interfaces__msg__SensorState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    kobuki_ros_interfaces__msg__SensorState__fini(msg);
    return false;
  }
  // time_stamp
  // bumper
  // wheel_drop
  // cliff
  // left_encoder
  // right_encoder
  // left_pwm
  // right_pwm
  // buttons
  // charger
  // battery
  // bottom
  if (!rosidl_generator_c__uint16__Sequence__init(&msg->bottom, 0)) {
    kobuki_ros_interfaces__msg__SensorState__fini(msg);
    return false;
  }
  // current
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->current, 0)) {
    kobuki_ros_interfaces__msg__SensorState__fini(msg);
    return false;
  }
  // over_current
  // digital_input
  // analog_input
  if (!rosidl_generator_c__uint16__Sequence__init(&msg->analog_input, 0)) {
    kobuki_ros_interfaces__msg__SensorState__fini(msg);
    return false;
  }
  return true;
}

void
kobuki_ros_interfaces__msg__SensorState__fini(kobuki_ros_interfaces__msg__SensorState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // time_stamp
  // bumper
  // wheel_drop
  // cliff
  // left_encoder
  // right_encoder
  // left_pwm
  // right_pwm
  // buttons
  // charger
  // battery
  // bottom
  rosidl_generator_c__uint16__Sequence__fini(&msg->bottom);
  // current
  rosidl_generator_c__uint8__Sequence__fini(&msg->current);
  // over_current
  // digital_input
  // analog_input
  rosidl_generator_c__uint16__Sequence__fini(&msg->analog_input);
}

kobuki_ros_interfaces__msg__SensorState *
kobuki_ros_interfaces__msg__SensorState__create()
{
  kobuki_ros_interfaces__msg__SensorState * msg = (kobuki_ros_interfaces__msg__SensorState *)malloc(sizeof(kobuki_ros_interfaces__msg__SensorState));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kobuki_ros_interfaces__msg__SensorState));
  bool success = kobuki_ros_interfaces__msg__SensorState__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
kobuki_ros_interfaces__msg__SensorState__destroy(kobuki_ros_interfaces__msg__SensorState * msg)
{
  if (msg) {
    kobuki_ros_interfaces__msg__SensorState__fini(msg);
  }
  free(msg);
}


bool
kobuki_ros_interfaces__msg__SensorState__Sequence__init(kobuki_ros_interfaces__msg__SensorState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  kobuki_ros_interfaces__msg__SensorState * data = NULL;
  if (size) {
    data = (kobuki_ros_interfaces__msg__SensorState *)calloc(size, sizeof(kobuki_ros_interfaces__msg__SensorState));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kobuki_ros_interfaces__msg__SensorState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kobuki_ros_interfaces__msg__SensorState__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kobuki_ros_interfaces__msg__SensorState__Sequence__fini(kobuki_ros_interfaces__msg__SensorState__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kobuki_ros_interfaces__msg__SensorState__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kobuki_ros_interfaces__msg__SensorState__Sequence *
kobuki_ros_interfaces__msg__SensorState__Sequence__create(size_t size)
{
  kobuki_ros_interfaces__msg__SensorState__Sequence * array = (kobuki_ros_interfaces__msg__SensorState__Sequence *)malloc(sizeof(kobuki_ros_interfaces__msg__SensorState__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = kobuki_ros_interfaces__msg__SensorState__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
kobuki_ros_interfaces__msg__SensorState__Sequence__destroy(kobuki_ros_interfaces__msg__SensorState__Sequence * array)
{
  if (array) {
    kobuki_ros_interfaces__msg__SensorState__Sequence__fini(array);
  }
  free(array);
}
